% This program calculates chemical balance of a process sequence "pseq" using balance matrix "BM".
% "w" is the maximal metabolite number.
function vt = btk_calc_balance(pseq, BM, w)
[pseqr,pseqc] = size(pseq);
[BMr,BMc] = size(BM);
if ( nargin == 2 )
     w = max(max(real(BM)));
end
ci = 1;
vt = zeros(1,w);
while (ci <= pseqc)
     if ( pseq(1,ci) == 0 )
          break;
     end
     pn = abs(pseq(1,ci));
     d = pseq(1,ci)/pn;
     j0 = 1;
     v = zeros(1,w);
     while ( j0 <= BMc )
          if ( BM(pn,j0) == 0 )
               break;
          end
          BMn = BM(pn,j0);
          v(1,real(BMn)) = v(1,real(BMn)) + imag(BMn);
          j0 = j0 + 1;
     end
     vt = vt + v*d;
     ci = ci + 1;
end
